include \masm32\MasmBasic\MasmBasic.inc

UseMB = 0	; 0=use new MB getkey, 1=use Masm32/CRT

.code
start:
	; CodeSize MbGetKey
	Print Str$("VK_F1=\t%i\n", VK_F1)
	Print Str$("VK_F12=\t%i\n", VK_F12)
	Print Str$("VK_LEFT=\t%i\n", VK_LEFT)
	Print Str$("VK_INSERT=\t%i\n", VK_INSERT)
	Print Str$("VK_NEXT=\t%i\n", VK_NEXT)
	Print "Char"
	if UseMB
		Print "/Virtual key"
	endif
	Print
	.Repeat
		if UseMB
			call MbGetKey
		else
			getkey
;			call ret_key		; Masm32, uses crt_getch
		endif
		.Break .if eax==27
		if 0
			Print Chr$(eax)	; WYSIWYG
		else
			if UseMB
				push edx
				Print Str$(eax), "/"
				pop eax
				PrintLine Str$(eax), " "
			else
				PrintLine Str$(eax), " "
			endif
		endif
	.Until 0
	Exit

MbGetKey_s:
MbGetKey proc
	push esi
	push ebx
	push ecx
	sub esp, INPUT_RECORD
	invoke GetStdHandle, STD_INPUT_HANDLE
	xchg eax, ebx
@@:	invoke FlushConsoleInputBuffer, ebx
	mov esi, esp	; pointer to buffer and retval #events
	invoke ReadConsoleInput, ebx, esi, 1, esi
	cmp [esi.INPUT_RECORD.KeyEvent.bKeyDown], 0
	je @B
	movzx eax, [esi.INPUT_RECORD.KeyEvent.UnicodeChar]
	movzx edx, [esi.INPUT_RECORD.KeyEvent.wVirtualKeyCode]
	.if !eax
		mov eax, edx
		test eax, eax
		je @B
	.endif
	cmp eax, VK_SHIFT
	je @B
	cmp eax, VK_CONTROL
	je @B
	cmp eax, VK_MENU
	je @B
	add esp, INPUT_RECORD
	pop ecx
	pop ebx
	pop esi
	ret
MbGetKey endp
MbGetKey_endp:

end start
